"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var functions_1 = require("../utils/functions");
var constants_1 = require("../utils/constants");
function ScrollAnimationItem(_a) {
    var children = _a.children, _b = _a.delay, delay = _b === void 0 ? 0 : _b, _c = _a.duration, duration = _c === void 0 ? 1200 : _c, _d = _a.path, path = _d === void 0 ? 'top' : _d, className = _a.className, _e = _a.offsetHeight, offsetHeight = _e === void 0 ? 0 : _e, rest = __rest(_a, ["children", "delay", "duration", "path", "className", "offsetHeight"]);
    var ref = react_1.default.useRef(null);
    var hashClassName = functions_1.generateHashStringByLength(5);
    var newClassName = (className || constants_1.basicClassName) + " ssa-" + hashClassName;
    function onScroll() {
        var element = functions_1.findDivByRef(ref.current);
        var _a = element.getBoundingClientRect(), elementTopPosition = _a.top, elementHeight = _a.height;
        if ((window.innerHeight + elementHeight) / 2 + offsetHeight >
            elementTopPosition) {
            functions_1.setShowScrollAnimation(element, duration, delay, path);
            functions_1.endShowAnimation(element, duration);
            window.removeEventListener('scroll', onScroll);
        }
    }
    react_1.default.useEffect(function () {
        functions_1.createKeyframes();
    }, []);
    react_1.default.useEffect(function () {
        window.addEventListener('scroll', onScroll);
        onScroll();
        return function () { return window.removeEventListener('scroll', onScroll); };
    }, []);
    return (jsx_runtime_1.jsx("div", __assign({ className: newClassName, style: styles, ref: ref }, rest, { children: children }), void 0));
}
exports.default = ScrollAnimationItem;
var styles = {
    opacity: 0,
};
//# sourceMappingURL=ScrollAnimationItem.js.map